// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Series.pas' rev: 3.00

#ifndef SeriesHPP
#define SeriesHPP
#include <TeeProcs.hpp>
#include <TeCanvas.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Chart.hpp>
#include <TeEngine.hpp>
#include <Windows.hpp>
#include <Graphics.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Series
{
//-- type declarations -------------------------------------------------------
enum TSeriesPointerStyle { psRectangle, psCircle, psTriangle, psDownTriangle, psCross, psDiagCross, 
	psStar, psDiamond, psSmallDot };

typedef TSeriesPointerStyle __fastcall (__closure *TOnGetPointerStyle)(Teengine::TChartSeries* Sender
	, int ValueIndex);

class DELPHICLASS TSeriesPointer;
class PASCALIMPLEMENTATION TSeriesPointer : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FDark3D;
	bool FDraw3D;
	Teengine::TChartBrush* FBrush;
	int FHorizSize;
	bool FInflateMargins;
	Teengine::TChartSeries* FOwner;
	Tecanvas::TChartPen* FPen;
	TSeriesPointerStyle FStyle;
	int FVertSize;
	bool FVisible;
	void __fastcall CheckPointerSize(int Value);
	void __fastcall SetDark3D(bool Value);
	void __fastcall SetDraw3D(bool Value);
	void __fastcall SetBrush(Teengine::TChartBrush* Value);
	void __fastcall SetHorizSize(int Value);
	void __fastcall SetInflateMargins(bool Value);
	void __fastcall SetPen(Tecanvas::TChartPen* Value);
	void __fastcall SetStyle(TSeriesPointerStyle Value);
	void __fastcall SetVertSize(int Value);
	void __fastcall SetVisible(bool Value);
	
protected:
	void __fastcall SetBooleanProperty(bool &Variable, bool Value);
	void __fastcall SetIntegerProperty(int &Variable, int Value);
	
public:
	bool AllowChangeSize;
	__fastcall TSeriesPointer(Teengine::TChartSeries* AOwner);
	__fastcall virtual ~TSeriesPointer(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall CalcHorizMargins(int &LeftMargin, int &RightMargin);
	void __fastcall CalcVerticalMargins(int &TopMargin, int &BottomMargin);
	void __fastcall Change3D(bool Value);
	void __fastcall ChangeHorizSize(int NewSize);
	void __fastcall ChangeStyle(TSeriesPointerStyle NewStyle);
	void __fastcall ChangeVertSize(int NewSize);
	void __fastcall Draw(int px, int py, Graphics::TColor ColorValue, TSeriesPointerStyle AStyle);
	void __fastcall DrawLegendShape(Graphics::TColor AColor, const Windows::TRect &Rect, bool DrawPen);
		
	void __fastcall DrawPointer(bool Is3D, int px, int py, int tmpHoriz, int tmpVert, Graphics::TColor 
		ColorValue, TSeriesPointerStyle AStyle);
	void __fastcall PrepareCanvas(Graphics::TColor ColorValue);
	__property Teengine::TChartSeries* ParentSeries = {read=FOwner};
	
__published:
	__property Teengine::TChartBrush* Brush = {read=FBrush, write=SetBrush};
	__property bool Dark3D = {read=FDark3D, write=SetDark3D, default=1};
	__property bool Draw3D = {read=FDraw3D, write=SetDraw3D, default=1};
	__property int HorizSize = {read=FHorizSize, write=SetHorizSize, default=4};
	__property bool InflateMargins = {read=FInflateMargins, write=SetInflateMargins, nodefault};
	__property Tecanvas::TChartPen* Pen = {read=FPen, write=SetPen};
	__property TSeriesPointerStyle Style = {read=FStyle, write=SetStyle, nodefault};
	__property int VertSize = {read=FVertSize, write=SetVertSize, default=4};
	__property bool Visible = {read=FVisible, write=SetVisible, nodefault};
};

class DELPHICLASS TCustomSeries;
typedef void __fastcall (__closure *TSeriesClickPointerEvent)(TCustomSeries* Sender, int ValueIndex, 
	int X, int Y);

class PASCALIMPLEMENTATION TCustomSeries : public Teengine::TChartSeries 
{
	typedef Teengine::TChartSeries inherited;
	
private:
	TBrushStyle FAreaBrush;
	Graphics::TColor FAreaColor;
	Tecanvas::TChartPen* FAreaLinesPen;
	bool FClickableLine;
	bool FDark3D;
	bool FDrawArea;
	bool FDrawLine;
	bool FInvertedStairs;
	TBrushStyle FLineBrush;
	int FLineHeight;
	Tecanvas::TChartPen* FLinePen;
	TSeriesPointer* FPointer;
	bool FStairs;
	TSeriesClickPointerEvent FOnClickPointer;
	TOnGetPointerStyle FOnGetPointerStyle;
	int BottomPos;
	int OldBottomPos;
	int OldX;
	int OldY;
	Graphics::TColor OldColor;
	double tmpDark3DRatio;
	void __fastcall SetAreaBrush(Graphics::TBrushStyle Value);
	void __fastcall SetAreaColor(Graphics::TColor Value);
	void __fastcall SetAreaLinesPen(Tecanvas::TChartPen* Value);
	void __fastcall SetBrushProperty(Graphics::TBrushStyle &ABrush, Graphics::TBrushStyle Value);
	void __fastcall SetDark3D(bool Value);
	void __fastcall SetDrawArea(bool Value);
	void __fastcall SetInvertedStairs(bool Value);
	void __fastcall SetLineBrush(Graphics::TBrushStyle Value);
	void __fastcall SetLineHeight(int Value);
	void __fastcall SetLinePen(Tecanvas::TChartPen* Value);
	void __fastcall SetPointer(TSeriesPointer* Value);
	void __fastcall SetStairs(bool Value);
	
protected:
	virtual bool __fastcall ClickedPointer(int ValueIndex, int tmpX, int tmpY, int x, int y);
	virtual void __fastcall DrawMark(int ValueIndex, const System::AnsiString St, Teengine::TSeriesMarkPosition* 
		APosition);
	virtual void __fastcall DrawPointer(int AX, int AY, Graphics::TColor AColor, int ValueIndex);
	virtual void __fastcall DrawValue(int ValueIndex);
	Graphics::TColor __fastcall GetAreaBrushColor(Graphics::TColor AColor);
	void __fastcall LinePrepareCanvas(Tecanvas::TCanvas3D* tmpCanvas, Graphics::TColor tmpColor);
	
public:
	__fastcall virtual TCustomSeries(Classes::TComponent* AOwner);
	__fastcall virtual ~TCustomSeries(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall CalcHorizMargins(int &LeftMargin, int &RightMargin);
	virtual void __fastcall CalcVerticalMargins(int &TopMargin, int &BottomMargin);
	virtual int __fastcall Clicked(int x, int y);
	virtual void __fastcall DrawLegendShape(int ValueIndex, const Windows::TRect &Rect);
	virtual System::AnsiString __fastcall GetEditorClass();
	virtual int __fastcall GetOriginPos(int ValueIndex);
	__property Graphics::TBrushStyle AreaBrush = {read=FAreaBrush, write=SetAreaBrush, default=0};
	__property Graphics::TColor AreaColor = {read=FAreaColor, write=SetAreaColor, nodefault};
	__property Tecanvas::TChartPen* AreaLinesPen = {read=FAreaLinesPen, write=SetAreaLinesPen};
	__property bool ClickableLine = {read=FClickableLine, write=FClickableLine, nodefault};
	__property bool Dark3D = {read=FDark3D, write=SetDark3D, default=1};
	__property bool DrawArea = {read=FDrawArea, write=SetDrawArea, default=0};
	__property bool InvertedStairs = {read=FInvertedStairs, write=SetInvertedStairs, default=0};
	__property Graphics::TBrushStyle LineBrush = {read=FLineBrush, write=SetLineBrush, default=0};
	__property int LineHeight = {read=FLineHeight, write=SetLineHeight, default=0};
	__property Tecanvas::TChartPen* LinePen = {read=FLinePen, write=SetLinePen};
	__property TSeriesClickPointerEvent OnClickPointer = {read=FOnClickPointer, write=FOnClickPointer};
		
	__property TSeriesPointer* Pointer = {read=FPointer, write=SetPointer};
	__property bool Stairs = {read=FStairs, write=SetStairs, default=0};
	
__published:
	__property TOnGetPointerStyle OnGetPointerStyle = {read=FOnGetPointerStyle, write=FOnGetPointerStyle
		};
};

class DELPHICLASS TLineSeries;
class PASCALIMPLEMENTATION TLineSeries : public Series::TCustomSeries 
{
	typedef Series::TCustomSeries inherited;
	
public:
	__fastcall virtual TLineSeries(Classes::TComponent* AOwner);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall PrepareLegendCanvas(int ValueIndex, Graphics::TColor &BackColor, Graphics::TBrushStyle 
		&BrushStyle);
	
__published:
	__property Dark3D ;
	__property InvertedStairs ;
	__property LineBrush ;
	__property LineHeight ;
	__property LinePen ;
	__property Pointer ;
	__property Stairs ;
	__property XValues ;
	__property YValues ;
public:
	/* TCustomSeries.Destroy */ __fastcall virtual ~TLineSeries(void) { }
	
};

class DELPHICLASS TPointSeries;
class PASCALIMPLEMENTATION TPointSeries : public Series::TCustomSeries 
{
	typedef Series::TCustomSeries inherited;
	
protected:
	virtual void __fastcall SetColorEachPoint(bool Value);
	
public:
	__fastcall virtual TPointSeries(Classes::TComponent* AOwner);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual System::AnsiString __fastcall GetEditorClass();
	virtual void __fastcall PrepareForGallery(bool IsEnabled);
	
__published:
	__property Pointer ;
	__property XValues ;
	__property YValues ;
	__property OnClickPointer ;
public:
	/* TCustomSeries.Destroy */ __fastcall virtual ~TPointSeries(void) { }
	
};

enum TMultiArea { maNone, maStacked, maStacked100 };

class DELPHICLASS TAreaSeries;
class PASCALIMPLEMENTATION TAreaSeries : public Series::TCustomSeries 
{
	typedef Series::TCustomSeries inherited;
	
private:
	TMultiArea FMultiArea;
	void __fastcall SetMultiArea(TMultiArea Value);
	void __fastcall SetOtherMultiArea(void);
	int __fastcall InternalCalcStackedYPos(int ValueIndex, double Value);
	
public:
	__fastcall virtual TAreaSeries(Classes::TComponent* AOwner);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall CalcZOrder(void);
	virtual int __fastcall CalcYPos(int ValueIndex);
	virtual System::AnsiString __fastcall GetEditorClass();
	virtual int __fastcall GetOriginPos(int ValueIndex);
	virtual void __fastcall PrepareLegendCanvas(int ValueIndex, Graphics::TColor &BackColor, Graphics::TBrushStyle 
		&BrushStyle);
	virtual double __fastcall MaxYValue(void);
	virtual double __fastcall MinYValue(void);
	
__published:
	__property AreaBrush ;
	__property AreaColor ;
	__property AreaLinesPen ;
	__property Dark3D ;
	__property DrawArea ;
	__property InvertedStairs ;
	__property LinePen ;
	__property TMultiArea MultiArea = {read=FMultiArea, write=SetMultiArea, default=0};
	__property Stairs ;
	__property XValues ;
	__property YValues ;
public:
	/* TCustomSeries.Destroy */ __fastcall virtual ~TAreaSeries(void) { }
	
};

class DELPHICLASS BarException;
class PASCALIMPLEMENTATION BarException : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall BarException(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall BarException(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall BarException(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall BarException(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall BarException(const System::AnsiString Msg, int AHelpContext) : 
		Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall BarException(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall BarException(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall BarException(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~BarException(void) { }
	
};

enum TMultiBar { mbNone, mbSide, mbStacked, mbStacked100 };

enum TBarStyle { bsRectangle, bsPyramid, bsInvPyramid, bsCilinder, bsEllipse, bsArrow, bsRectGradient 
	};

class DELPHICLASS TCustomBarSeries;
typedef void __fastcall (__closure *TGetBarStyleEvent)(TCustomBarSeries* Sender, int ValueIndex, TBarStyle 
	&TheBarStyle);

class PASCALIMPLEMENTATION TCustomBarSeries : public Teengine::TChartSeries 
{
	typedef Teengine::TChartSeries inherited;
	
private:
	bool FAutoBarSize;
	bool FAutoMarkPosition;
	Teengine::TChartBrush* FBarBrush;
	Tecanvas::TChartPen* FBarPen;
	TBarStyle FBarStyle;
	int FBarWidthPercent;
	int FCustomBarSize;
	bool FDark3D;
	TMultiBar FMultiBar;
	int FOffsetPercent;
	bool FSideMargins;
	bool FUseOrigin;
	double FOrigin;
	TGetBarStyleEvent FOnGetBarStyle;
	int IBarSize;
	Windows::TRect FBarBounds;
	void __fastcall CalcBarWidth(void);
	virtual int __fastcall InternalCalcMarkLength(int ValueIndex) = 0;
	void __fastcall SetAutoBarSize(bool Value);
	void __fastcall SetAutoMarkPosition(bool Value);
	void __fastcall SetBarWidthPercent(int Value);
	void __fastcall SetOffsetPercent(int Value);
	void __fastcall SetBarStyle(TBarStyle Value);
	void __fastcall SetDark3d(bool Value);
	void __fastcall SetUseOrigin(bool Value);
	void __fastcall SetSideMargins(bool Value);
	void __fastcall SetBarPen(Tecanvas::TChartPen* Value);
	void __fastcall SetBarBrush(Teengine::TChartBrush* Value);
	void __fastcall SetOrigin(const double Value);
	void __fastcall SetMultiBar(TMultiBar Value);
	void __fastcall SetOtherMultiBar(void);
	void __fastcall AdjustGradientRectPen(Windows::TRect &R);
	int __fastcall BarOrderPos(void);
	int __fastcall BarSeriesCount(void);
	double __fastcall MaxMandatoryValue(const double Value, Teengine::TChartValueList* AList);
	double __fastcall MinMandatoryValue(const double Value);
	void __fastcall InternalApplyBarMargin(int &MarginA, int &MarginB);
	
protected:
	virtual bool __fastcall InternalClicked(int ValueIndex, const tagPOINT &APoint);
	int __fastcall InternalGetOriginPos(int ValueIndex, int DefaultOrigin);
	void __fastcall SetCustomBarSize(int Value);
	
public:
	Graphics::TColor NormalBarColor;
	__fastcall virtual TCustomBarSeries(Classes::TComponent* AOwner);
	__fastcall virtual ~TCustomBarSeries(void);
	int __fastcall AddBar(const double AValue, const System::AnsiString ALabel, Graphics::TColor AColor
		);
	int __fastcall ApplyBarOffset(int Position);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	int __fastcall BarMargin(void);
	void __fastcall BarRectangle(Graphics::TColor BarColor, int ALeft, int ATop, int ARight, int ABottom
		);
	int __fastcall CalcMarkLength(int ValueIndex);
	virtual void __fastcall CalcZOrder(void);
	virtual int __fastcall Clicked(int x, int y);
	virtual void __fastcall DrawLegendShape(int ValueIndex, const Windows::TRect &Rect);
	TBarStyle __fastcall GetBarStyle(int ValueIndex);
	virtual System::AnsiString __fastcall GetEditorClass();
	virtual int __fastcall NumSampleValues(void);
	virtual double __fastcall PointOrigin(int ValueIndex, bool SumAll);
	virtual void __fastcall PrepareForGallery(bool IsEnabled);
	virtual void __fastcall PrepareLegendCanvas(int ValueIndex, Graphics::TColor &BackColor, Graphics::TBrushStyle 
		&BrushStyle);
	void __fastcall SetPenBrushBar(Graphics::TColor BarColor);
	__property Windows::TRect BarBounds = {read=FBarBounds};
	
__published:
	__property bool AutoBarSize = {read=FAutoBarSize, write=SetAutoBarSize, default=0};
	__property bool AutoMarkPosition = {read=FAutoMarkPosition, write=SetAutoMarkPosition, default=1};
	__property Teengine::TChartBrush* BarBrush = {read=FBarBrush, write=SetBarBrush};
	__property Tecanvas::TChartPen* BarPen = {read=FBarPen, write=SetBarPen};
	__property TBarStyle BarStyle = {read=FBarStyle, write=SetBarStyle, default=0};
	__property int BarWidthPercent = {read=FBarWidthPercent, write=SetBarWidthPercent, default=70};
	__property bool Dark3D = {read=FDark3D, write=SetDark3d, default=1};
	__property TMultiBar MultiBar = {read=FMultiBar, write=SetMultiBar, default=1};
	__property int OffsetPercent = {read=FOffsetPercent, write=SetOffsetPercent, default=0};
	__property bool SideMargins = {read=FSideMargins, write=SetSideMargins, default=1};
	__property bool UseYOrigin = {read=FUseOrigin, write=SetUseOrigin, default=1};
	__property double YOrigin = {read=FOrigin, write=SetOrigin};
	__property XValues ;
	__property YValues ;
	__property TGetBarStyleEvent OnGetBarStyle = {read=FOnGetBarStyle, write=FOnGetBarStyle};
};

class DELPHICLASS TBarSeries;
class PASCALIMPLEMENTATION TBarSeries : public Series::TCustomBarSeries 
{
	typedef Series::TCustomBarSeries inherited;
	
private:
	virtual int __fastcall InternalCalcMarkLength(int ValueIndex);
	
protected:
	virtual void __fastcall DrawValue(int ValueIndex);
	virtual void __fastcall DrawMark(int ValueIndex, const System::AnsiString St, Teengine::TSeriesMarkPosition* 
		APosition);
	
public:
	virtual bool __fastcall InternalClicked(int ValueIndex, const tagPOINT &APoint);
	virtual void __fastcall CalcHorizMargins(int &LeftMargin, int &RightMargin);
	virtual void __fastcall CalcVerticalMargins(int &TopMargin, int &BottomMargin);
	virtual int __fastcall CalcXPos(int ValueIndex);
	virtual int __fastcall CalcYPos(int ValueIndex);
	virtual void __fastcall DrawBar(int BarIndex, int StartPos, int EndPos);
	virtual bool __fastcall DrawSeriesForward(int ValueIndex);
	virtual bool __fastcall DrawValuesForward(void);
	int __fastcall GetOriginPos(int ValueIndex);
	virtual double __fastcall MaxYValue(void);
	virtual double __fastcall MinYValue(void);
	__property int BarWidth = {read=IBarSize, nodefault};
	
__published:
	__property int CustomBarWidth = {read=FCustomBarSize, write=SetCustomBarSize, default=0};
public:
	/* TCustomBarSeries.Create */ __fastcall virtual TBarSeries(Classes::TComponent* AOwner) : Series::
		TCustomBarSeries(AOwner) { }
	/* TCustomBarSeries.Destroy */ __fastcall virtual ~TBarSeries(void) { }
	
};

class DELPHICLASS THorizBarSeries;
class PASCALIMPLEMENTATION THorizBarSeries : public Series::TCustomBarSeries 
{
	typedef Series::TCustomBarSeries inherited;
	
private:
	virtual int __fastcall InternalCalcMarkLength(int ValueIndex);
	
protected:
	virtual void __fastcall DrawValue(int ValueIndex);
	virtual void __fastcall DrawMark(int ValueIndex, const System::AnsiString St, Teengine::TSeriesMarkPosition* 
		APosition);
	
public:
	virtual bool __fastcall InternalClicked(int ValueIndex, const tagPOINT &APoint);
	virtual void __fastcall CalcHorizMargins(int &LeftMargin, int &RightMargin);
	virtual void __fastcall CalcVerticalMargins(int &TopMargin, int &BottomMargin);
	virtual int __fastcall CalcXPos(int ValueIndex);
	virtual int __fastcall CalcYPos(int ValueIndex);
	virtual void __fastcall DrawBar(int BarIndex, int StartPos, int EndPos);
	virtual bool __fastcall DrawSeriesForward(int ValueIndex);
	virtual bool __fastcall DrawValuesForward(void);
	virtual void __fastcall FillSampleValues(int NumValues);
	int __fastcall GetOriginPos(int ValueIndex);
	virtual Teengine::TChartValueList* __fastcall MandatoryValueList(void);
	virtual double __fastcall MaxXValue(void);
	virtual double __fastcall MinXValue(void);
	__property int BarHeight = {read=IBarSize, nodefault};
	
__published:
	__property int CustomBarHeight = {read=FCustomBarSize, write=SetCustomBarSize, default=0};
public:
	/* TCustomBarSeries.Create */ __fastcall virtual THorizBarSeries(Classes::TComponent* AOwner) : Series::
		TCustomBarSeries(AOwner) { }
	/* TCustomBarSeries.Destroy */ __fastcall virtual ~THorizBarSeries(void) { }
	
};

class DELPHICLASS TCircledSeries;
class PASCALIMPLEMENTATION TCircledSeries : public Teengine::TChartSeries 
{
	typedef Teengine::TChartSeries inherited;
	
private:
	bool FCircled;
	int FRotationAngle;
	int FCustomXRadius;
	int FCustomYRadius;
	int FXRadius;
	int FYRadius;
	Graphics::TColor FCircleBackColor;
	double IRotDegree;
	int FCircleWidth;
	int FCircleHeight;
	int FCircleXCenter;
	int FCircleYCenter;
	Windows::TRect FCircleRect;
	void __fastcall SetCircleBackColor(Graphics::TColor Value);
	void __fastcall SetCustomXRadius(int Value);
	void __fastcall SetCustomYRadius(int Value);
	void __fastcall SetCircled(bool Value);
	void __fastcall SetOtherCustomRadius(bool IsXRadius, int Value);
	void __fastcall SetRotationAngle(int Value);
	
protected:
	void __fastcall AdjustCircleRect(void);
	Graphics::TColor __fastcall CalcCircleBackColor(void);
	void __fastcall CalcRadius(void);
	virtual void __fastcall DoBeforeDrawValues(void);
	virtual void __fastcall SetActive(bool Value);
	virtual void __fastcall SetParentChart(Teengine::TCustomAxisPanel* Value);
	
public:
	__fastcall virtual TCircledSeries(Classes::TComponent* AOwner);
	__fastcall virtual ~TCircledSeries(void);
	void __fastcall AngleToPos(const double Angle, const double AXRadius, const double AYRadius, int &X
		, int &Y);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual bool __fastcall AssociatedToAxis(Teengine::TCustomChartAxis* Axis);
	double __fastcall PointToAngle(int x, int y);
	virtual void __fastcall PrepareLegendCanvas(int ValueIndex, Graphics::TColor &BackColor, Graphics::TBrushStyle 
		&BrushStyle);
	void __fastcall Rotate(int Angle);
	virtual void __fastcall SetParentProperties(bool EnableParentProps);
	virtual bool __fastcall UseAxis(void);
	__property int XRadius = {read=FXRadius, nodefault};
	__property int YRadius = {read=FYRadius, nodefault};
	__property int CircleXCenter = {read=FCircleXCenter, nodefault};
	__property int CircleYCenter = {read=FCircleYCenter, nodefault};
	__property int CircleWidth = {read=FCircleWidth, nodefault};
	__property int CircleHeight = {read=FCircleHeight, nodefault};
	__property Windows::TRect CircleRect = {read=FCircleRect};
	__property Graphics::TColor CircleBackColor = {read=FCircleBackColor, write=SetCircleBackColor, nodefault
		};
	__property int RotationAngle = {read=FRotationAngle, write=SetRotationAngle, default=0};
	
__published:
	__property bool Circled = {read=FCircled, write=SetCircled, default=0};
	__property int CustomXRadius = {read=FCustomXRadius, write=SetCustomXRadius, default=0};
	__property int CustomYRadius = {read=FCustomYRadius, write=SetCustomYRadius, default=0};
};

class DELPHICLASS PieException;
class PASCALIMPLEMENTATION PieException : public Teeprocs::ChartException 
{
	typedef Teeprocs::ChartException inherited;
	
public:
	/* Exception.Create */ __fastcall PieException(const System::AnsiString Msg) : Teeprocs::ChartException(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall PieException(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Teeprocs::ChartException(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall PieException(int Ident, Extended Dummy) : Teeprocs::ChartException(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall PieException(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Teeprocs::ChartException(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall PieException(const System::AnsiString Msg, int AHelpContext) : 
		Teeprocs::ChartException(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall PieException(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Teeprocs::ChartException(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall PieException(int Ident, int AHelpContext) : Teeprocs::ChartException(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall PieException(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Teeprocs::ChartException(Ident, Args, Args_Size, AHelpContext) { }
		
	
public:
	/* TObject.Destroy */ __fastcall virtual ~PieException(void) { }
	
};

class DELPHICLASS TPieAngle;
class PASCALIMPLEMENTATION TPieAngle : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	double StartAngle;
	double MidAngle;
	double EndAngle;
public:
	/* TObject.Create */ __fastcall TPieAngle(void) : System::TObject() { }
	/* TObject.Destroy */ __fastcall virtual ~TPieAngle(void) { }
	
};

class DELPHICLASS TPieAngles;
class PASCALIMPLEMENTATION TPieAngles : public Classes::TList 
{
	typedef Classes::TList inherited;
	
private:
	TPieAngle* __fastcall GetAngle(int Index);
	
public:
	__property TPieAngle* Angle[int Index] = {read=GetAngle/*, default*/};
public:
	/* TList.Destroy */ __fastcall virtual ~TPieAngles(void) { }
	
public:
	/* TObject.Create */ __fastcall TPieAngles(void) : Classes::TList() { }
	
};

class DELPHICLASS TExplodedSlices;
class PASCALIMPLEMENTATION TExplodedSlices : public Classes::TList 
{
	typedef Classes::TList inherited;
	
private:
	void __fastcall SetValue(int Index, int Value);
	int __fastcall GetValue(int Index);
	
public:
	Teengine::TChartSeries* OwnerSeries;
	__property int Value[int Index] = {read=GetValue, write=SetValue/*, default*/};
public:
	/* TList.Destroy */ __fastcall virtual ~TExplodedSlices(void) { }
	
public:
	/* TObject.Create */ __fastcall TExplodedSlices(void) : Classes::TList() { }
	
};

enum TPieOtherStyle { poNone, poBelowPercent, poBelowValue };

class DELPHICLASS TPieOtherSlice;
class PASCALIMPLEMENTATION TPieOtherSlice : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TPieOtherStyle FStyle;
	System::AnsiString FText;
	double FValue;
	Teengine::TChartSeries* FOwner;
	void __fastcall SetStyle(TPieOtherStyle Value);
	void __fastcall SetText(const System::AnsiString Value);
	void __fastcall SetValue(const double Value);
	
public:
	__fastcall TPieOtherSlice(Teengine::TChartSeries* AOwner);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property TPieOtherStyle Style = {read=FStyle, write=SetStyle, default=0};
	__property System::AnsiString Text = {read=FText, write=SetText};
	__property double Value = {read=FValue, write=SetValue};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TPieOtherSlice(void) { }
	
};

class DELPHICLASS TPieSeries;
class PASCALIMPLEMENTATION TPieSeries : public Series::TCircledSeries 
{
	typedef Series::TCircledSeries inherited;
	
private:
	bool FDark3d;
	TExplodedSlices* FExplodedSlice;
	int FExplodeBiggest;
	Tecanvas::TChartPen* FPiePen;
	TPieOtherSlice* FOtherSlice;
	bool FUsePatterns;
	void __fastcall DisableRotation(void);
	void __fastcall FreePieAngles(void);
	void __fastcall SetUsePatterns(bool Value);
	void __fastcall SetDark3d(bool Value);
	Teengine::TChartValueList* __fastcall GetPieValues(void);
	void __fastcall SetPieValues(Teengine::TChartValueList* Value);
	void __fastcall SetExplodeBiggest(int Value);
	void __fastcall SetPiePen(Tecanvas::TChartPen* Value);
	void __fastcall SetOtherSlice(TPieOtherSlice* Value);
	void __fastcall CalcExplodeBiggest(void);
	void __fastcall CalcExplodedOffset(int ValueIndex, int &OffsetX, int &OffsetY);
	
protected:
	TPieAngles* FAngles;
	int IniX;
	int IniY;
	int EndX;
	int EndY;
	bool IsExploded;
	void __fastcall CalcAngles(void);
	void __fastcall CalcExplodedRadius(int ValueIndex, int &AXRadius, int &AYRadius);
	virtual void __fastcall DoBeforeDrawChart(void);
	virtual void __fastcall DrawAllValues(void);
	virtual void __fastcall DrawPie(int ValueIndex);
	virtual void __fastcall DrawValue(int ValueIndex);
	virtual void __fastcall DrawMark(int ValueIndex, const System::AnsiString St, Teengine::TSeriesMarkPosition* 
		APosition);
	virtual void __fastcall ClearLists(void);
	
public:
	__fastcall virtual TPieSeries(Classes::TComponent* AOwner);
	__fastcall virtual ~TPieSeries(void);
	int __fastcall AddPie(const double AValue, const System::AnsiString ALabel, Graphics::TColor AColor
		);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	bool __fastcall BelongsToOtherSlice(int ValueIndex);
	int __fastcall CalcClickedPie(int x, int y);
	virtual int __fastcall CalcXPos(int ValueIndex);
	virtual int __fastcall Clicked(int x, int y);
	virtual int __fastcall CountLegendItems(void);
	virtual void __fastcall FillSampleValues(int NumValues);
	virtual void __fastcall GalleryChanged3D(bool Is3D);
	virtual System::AnsiString __fastcall GetEditorClass();
	virtual int __fastcall LegendToValueIndex(int LegendIndex);
	virtual double __fastcall MaxXValue(void);
	virtual double __fastcall MinXValue(void);
	virtual double __fastcall MaxYValue(void);
	virtual double __fastcall MinYValue(void);
	virtual int __fastcall NumSampleValues(void);
	virtual void __fastcall PrepareForGallery(bool IsEnabled);
	virtual void __fastcall PrepareLegendCanvas(int ValueIndex, Graphics::TColor &BackColor, Graphics::TBrushStyle 
		&BrushStyle);
	virtual void __fastcall SwapValueIndex(int a, int b);
	__property TPieAngles* Angles = {read=FAngles};
	__property TExplodedSlices* ExplodedSlice = {read=FExplodedSlice};
	
__published:
	__property CircleBackColor ;
	__property ColorEachPoint ;
	__property bool Dark3D = {read=FDark3d, write=SetDark3d, default=1};
	__property int ExplodeBiggest = {read=FExplodeBiggest, write=SetExplodeBiggest, default=0};
	__property TPieOtherSlice* OtherSlice = {read=FOtherSlice, write=SetOtherSlice};
	__property Tecanvas::TChartPen* PiePen = {read=FPiePen, write=SetPiePen};
	__property Teengine::TChartValueList* PieValues = {read=GetPieValues, write=SetPieValues};
	__property RotationAngle ;
	__property bool UsePatterns = {read=FUsePatterns, write=SetUsePatterns, default=0};
};

class DELPHICLASS TFastLineSeries;
class PASCALIMPLEMENTATION TFastLineSeries : public Teengine::TChartSeries 
{
	typedef Teengine::TChartSeries inherited;
	
private:
	bool FAutoRepaint;
	Tecanvas::TChartPen* FLinePen;
	int OldX;
	int OldY;
	void __fastcall SetLinePen(Tecanvas::TChartPen* Value);
	
protected:
	virtual void __fastcall DrawValue(int ValueIndex);
	virtual void __fastcall DrawAllValues(void);
	virtual void __fastcall SetSeriesColor(Graphics::TColor AColor);
	void __fastcall PrepareCanvas(void);
	virtual void __fastcall DrawMark(int ValueIndex, const System::AnsiString St, Teengine::TSeriesMarkPosition* 
		APosition);
	
public:
	__fastcall virtual TFastLineSeries(Classes::TComponent* AOwner);
	__fastcall virtual ~TFastLineSeries(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual int __fastcall Clicked(int x, int y);
	virtual void __fastcall DrawLegendShape(int ValueIndex, const Windows::TRect &Rect);
	virtual System::AnsiString __fastcall GetEditorClass();
	virtual void __fastcall NotifyNewValue(Teengine::TChartSeries* Sender, int ValueIndex);
	
__published:
	__property bool AutoRepaint = {read=FAutoRepaint, write=FAutoRepaint, default=1};
	__property Tecanvas::TChartPen* LinePen = {read=FLinePen, write=SetLinePen};
	__property XValues ;
	__property YValues ;
};

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE double TwoPi;
extern PACKAGE double HalfPi;
extern PACKAGE double PiDegree;

}	/* namespace Series */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Series;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// Series
